/*
 *  CardOSError.h
 *
 *  Copyright (c) 2011 Atos IT Solutions and Services GmbH
 *
 *  CardOS TokenD implementation based on XYZError.h provided 
 *  as part of the Apple TokenD developer information available from 
 *  dts@apple.com .
 *
 *  Use diff -c XYZError.h CardOSError.h to generate a patch.
 *
 *  See below for the copyright notice of the original file
 *  and the license applying to both the original and modified code.
 *
 *  Copyright (c) 2004 Apple Computer, Inc. All Rights Reserved.
 * 
 *  @APPLE_LICENSE_HEADER_START@
 *  
 *  This file contains Original Code and/or Modifications of Original Code
 *  as defined in and that are subject to the Apple Public Source License
 *  Version 2.0 (the 'License'). You may not use this file except in
 *  compliance with the License. Please obtain a copy of the License at
 *  http://www.opensource.apple.com/apsl/ and read it before using this
 *  file.
 *  
 *  The Original Code and all software distributed under the License are
 *  distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 *  EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 *  INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 *  Please see the License for the specific language governing rights and
 *  limitations under the License.
 *  
 *  @APPLE_LICENSE_HEADER_END@
 */

#ifndef _CARDOSERROR_H_
#define _CARDOSERROR_H_

#include <security_cdsa_utilities/cssmerrors.h>
#include <Security/cssmerr.h>

#include <CardOSAPI_Token/CardOSAPI_Token.h>


class CardOSError : public CssmError
{
protected:
  CardOSError(CSSM_RETURN err);
public:
  virtual const char *what () const throw ();
  
  static void check(const net_atos_cardos_api::CardOSAPI_Exception & cardosEx);
  static void throwMe(const net_atos_cardos_api::CardOSAPI_Exception &) __attribute__((noreturn));
protected:
  IFDEBUG(void debugDiagnose(const void *id) const;)
};

#endif /* _CARDOSERROR_H_ */
